# -*- makefile -*-
#
# $Id: Makefile.gnu,v 1.1 2001/10/15 11:04:09 cvser Exp $
#

.SUFFIXES: .C $(SUFFIXES)

VERSION     = 2.01
DWLIB       = lib/libdwclient-$(VERSION).a
DWLIB_R     = lib/libdwclient-$(VERSION)_r.a

CC          = ___CC___
ADDFLAGS    = ___OPT_FLAGS___
OPTFLAGS    = 
DEFFLAGS    = -D__UNIX_DW -D___OS_TYPE___
INCFLAGS    = -I./include
ADD_CFLAGS  = $(OPTFLAGS) $(DEFFLAGS) $(INCFLAGS) $(ADDFLAGS)

LINKLIB     = -L./lib -ldwclient ___OS_LIB___
LINKLIBMT   = -L./lib -ldwclient_r ___THR_LIB___ ___OS_LIB___
LIBMILTER   = -lmilter ___SM_LIB___

LIBINCLUDES = \
	include/dwc_lib.h\
	include/dwc_scan.h\
	include/dwc_macro.h

SMSRCS	= \
	dw_filter.c\
	dwf_main.c

SMOBJS = $(SMSRCS:.c=.o)

all : drwebdc ___DWFSM___ ___DWFCGP___

drwebdc : drwebdc.o $(DWLIB)
	$(CC) drwebdc.o -o $@ $(LINKLIB)

drweb-cgp : drweb_cgp.o $(DWLIB_R)
	$(CC) drweb_cgp.o -o $@ $(LINKLIBMT)

drweb-smf : $(SMOBJS) $(DWLIB_R)
	$(CC) $(SMOBJS) -o $@ $(LINKLIBMT) $(LIBMILTER)

drweb_cgp.o: drweb_cgp.c $(LIBINCLUDES)
	$(CC) -c $(ADD_CFLAGS) $< -I./src -D__THREAD_BASED_DW

%.o: %.c $(LIBINCLUDES)
	$(CC) -c $(ADD_CFLAGS) $<

include/%.h : src/%.h
	@( cd src; make headers )

$(DWLIB):
	@( cd src; make lib )

$(DWLIB_R):
	@( cd src; make lib_r )

clean:
	@( cd src; make clean )
	rm -f *.bak *~ *.err *.o drwebdc drweb-smf drweb-cgp
