# -*- makefile -*-
#
# $Id: Makefile.gnu,v 1.2 2001/10/16 15:03:59 cvser Exp $
#

.SUFFIXES: .C $(SUFFIXES)

VERSION     = 2.01

CC	        = ___CC___
ADDFLAGS    = ___OPT_FLAGS___
DEFFLAGS    = -D__UNIX_DW -D___OS_TYPE___
ADD_CFLAGS	= $(DEFFLAGS) $(ADDFLAGS)

SRCS	= \
	dwc_timo.c\
	dwc_mutex.c\
	dwc_event.c\
	dwc_thread.c\
	dwc_err.c\
	dwc_unix.c\
	dwc_tcp.c\
	dwc_log.c\
	dwc_ipc.c\
	dwc_lib.c

LIB_HDRS = \
	../include/dwc_lib.h\
	../include/dwc_scan.h\
	../include/dwc_macro.h
    
OBJS = $(SRCS:.c=.o)
MT_OBJS = $(SRCS:.c=_r.o)

all : lib lib_r headers

lib : libdwclient-$(VERSION).a

lib_r : libdwclient-$(VERSION)_r.a

headers: $(LIB_HDRS)

../include/%.h: %.h
	cp -f $< $@

libdwclient-$(VERSION).a : $(OBJS)
	$(AR) ruv $@ $(OBJS)
	ranlib $@
	mv $@ ../lib
	ln -s ../lib/$@ ../lib/libdwclient.a

libdwclient-$(VERSION)_r.a: $(MT_OBJS)	
	$(AR) ruv $@ $(MT_OBJS)
	ranlib $@ 
	mv $@ ../lib
	ln -s ../lib/$@ ../lib/libdwclient_r.a

%.o: %.c
	$(CC) -c $(ADD_CFLAGS) -D__SIGNAL_BASED_DW $< -o $@
    
%_r.o: %.c
	$(CC) -c $(ADD_CFLAGS) -D__THREAD_BASED_DW $< -o $@

clean:
	rm -f *.bak *~ *.err *.o ../lib/libdwclient*.a ../include/*.h
    
