#ifndef _DWC_ERR_C
#define _DWC_ERR_C

#if defined(__WIN32_DW)
#include <windows.h>
#endif /* __WIN32_DW */
#if defined(__UNIX_DW)
#include <string.h>
#endif /* __UNIX_DW */

#include <stdlib.h>
#include "dwc_lib.h"

/* -------------------------------------------------- */
char* stdlib_error(int code)
{
    /* asv: currently not thread-safe */
#if defined(__WIN32_DW)
    static char err[100];

    FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM, NULL, code, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), err, sizeof(err)-1, NULL ); 
    return err;
#endif /* __WIN32_DW */
#if defined(__UNIX_DW)
    return strerror(code);
#endif /* __UNIX_DW */
}

#endif /* _DWC_ERR_C */
