#ifndef __DRWEBD_SCAN_H
#define __DRWEBD_SCAN_H

/* $Id: dwc_scan.h,v 1.11 2001/10/04 14:29:03 cvser Exp $ */

/*--------------------------------------------------------------------------
 Dr. Web daemon & client scan commands, options & results codes
                                       ID Antivirus Lab http://www.drweb.ru
                                        http://www.drweb.ru/linux-bsd/forum
                                              http://www.drweb.ru/linux-bsd
--------------------------------------------------------------------------*/

/* -- SCAN_COMMANDS -------------------------------------------------- */
#define DRWEBD_SCAN_CMD             (1)     /* scan file, buffer or diskfile */
#define DRWEBD_VERSION_CMD          (2)     /* get daemon version */
#define DRWEBD_BASEINFO_CMD         (3)     /* get info about viruses bases */
#define DRWEBD_IDSTRING_CMD         (4)     /* get id-string of daemon */
#define DRWEBD_SCANPART_CMD         (5)     /* scan part of diskfile */

/* -- SCAN_OPTIONS ---------------------------------------------------- */
#define DRWEBD_RETURN_VIRUSES       (1<<0)  /* return viruses name */
#define DRWEBD_RETURN_REPORT        (1<<1)  /* return report line */
#define DRWEBD_RETURN_CODES         (1<<2)  /* return codes */
#define DRWEBD_HEURISTIC_ON         (1<<3)  /* enables heuristic */
#define DRWEBD_CURE_FILES           (1<<0)  /* 4 disabled now : enables curing */
#define DRWEBD_SPAM_FILTER          (1<<5)  /* enables spam filter in daemon */
#define DRWEBD_MAIL_MESSAGE         (1<<0)  /* 6 disabled now : just helpful info for daemon */

/* -- SCAN_RESALT ----------------------------------------------------- */
#define DERR_NOERROR                (0)     /*= 0x00000000 */
#define DERR_READ_ERR               (1<<0)  /*= 0x00000001 */
#define DERR_WRITE_ERR              (1<<1)  /*= 0x00000002 */               
#define DERR_NOMEMORY               (1<<2)  /*= 0x00000004 */            
#define DERR_CRC_ERROR              (1<<3)  /*= 0x00000008 */            
#define DERR_READSOCKET             (1<<4)  /*= 0x00000010 */             
#define DERR_KNOWN_VIRUS            (1<<5)  /*= 0x00000020 */            
#define DERR_UNKNOWN_VIRUS          (1<<6)  /*= 0x00000040 */               
#define DERR_VIRUS_MODIFICATION     (1<<7)  /*= 0x00000080 */             
#define DERR_FILE_IS_CURED          (1<<8)  /*= 0x00000100 */             
#define DERR_TIMEOUT                (1<<9)  /*= 0x00000200 */              
#define DERR_SYMLINK                (1<<10) /*= 0x00000400 */            
#define DERR_NO_REGFILE             (1<<11) /*= 0x00000800 */             
#define DERR_SKIPPED                (1<<12) /*= 0x00001000 */           
#define DERR_TOO_BIG                (1<<13) /*= 0x00002000 */            
#define DERR_TOO_COMPRESSED         (1<<14) /*= 0x00004000 */           
#define DERR_BAD_CALL               (1<<15) /*= 0x00008000 */            
#define DERR_EVAL_KEY               (1<<16) /*= 0x00010000 */            
#define DERR_SPAM                   (1<<17) /*= 0x00020000 */            
#define DERR_MASK                   (0x000FFFFF)
#define DERR_VIRUS_MASK             (DERR_KNOWN_VIRUS | DERR_UNKNOWN_VIRUS | DERR_VIRUS_MODIFICATION)
#define DERR_SKIP_OBJECT            (DERR_SYMLINK | DERR_NO_REGFILE | DERR_SKIPPED | DERR_CRC_ERROR)
#define DERR_MAIL_BOMB              (DERR_TOO_BIG | DERR_TOO_COMPRESSED)
#define DERR_DAEMON_ERROR           (DERR_READ_ERR | DERR_WRITE_ERR | DERR_NOMEMORY | DERR_READSOCKET | DERR_TIMEOUT | DERR_BAD_CALL)

#endif /* __DRWEBD_SCAN_H */
