#if defined(__THREAD_BASED_DW)

#ifndef _DWC_THREAD_H
#define _DWC_THREAD_H

/* $Id: dwc_thread.h,v 1.6 2001/10/16 15:03:59 cvser Exp $ */

#ifdef __UNIX_DW
#include <sys/types.h>
#include <pthread.h>
#endif /* __UNIX_DW */
#ifdef __WIN32_DW
#include <windows.h>
#endif /* __WIN32_DW */

#include "dwc_type.h"

typedef struct {
#ifdef __UNIX_DW
    pthread_t     id;
#endif /* __UNIX_DW */
#ifdef __WIN32_DW
    DWORD         id;
#endif /* __WIN32_DW */    
} DWC_thread_id_t;

typedef void*                      DWC_thread_arg_t;
typedef void                     (*DWC_thread_func_t)(DWC_thread_arg_t);

DWC_error_code_t     dwc_thread_create( DWC_thread_func_t, DWC_thread_arg_t );
DWC_error_code_t     dwc_thread_get_id( DWC_thread_id_t* );
DWC_bool_t           dwc_thread_isself( DWC_thread_id_t* );

#endif /* _DWC_THREAD_H */

#endif /* __THREAD_BASED_DW */
