#ifndef _DWC_TYPE_H
#define _DWC_TYPE_H

/* $Id: dwc_type.h,v 1.10 2001/09/18 15:26:49 cvser Exp $ */

#if defined(__WIN32_DW) && defined(__UNIX_DW)
#error "You can not defined __WIN32_DW && __UNIX_DW together"
#endif /* __WIN32_DW && __UNIX_DW */
#if !defined(__WIN32_DW) && !defined(__UNIX_DW)
#error "You should define __WIN32_DW or __UNIX_DW"
#endif /* not __WIN32_DW && not __UNIX_DW */

#if defined(__SIGNAL_BASED_DW) && defined(__THREAD_BASED_DW)
#error "You can not defined __SIGNAL_BASED_DW && __THREAD_BASED_DW together"
#endif /* __SIGNAL_BASED_DW && __THREAD_BASED_DW */
#if !defined(__SIGNAL_BASED_DW) && !defined(__THREAD_BASED_DW)
#error "You should define __SIGNAL_BASED_DW or __THREAD_BASED_DW"
#endif /* not __SIGNAL_BASED_DW && not __THREAD_BASED_DW */

#if defined(__WIN32_DW)
#include <stdio.h>
#endif
#include <sys/types.h>

#define DWC_IPC_WAIT_RECV   (1<<1)
#define DWC_IPC_WAIT_SEND   (1<<2)
#define DWC_IPC_WAIT_EXCP   (1<<3)
    
typedef enum {
    DWC_IPC_TYPE_0 = 0,
    DWC_IPC_TCP_SOCKET,
    DWC_IPC_UNIX_SOCKET,
    DWC_IPC_TYPE_MAX
}                   DWC_ipc_type_t;
typedef enum {
    DWC_IPC_SIDE_0 = 0,
    DWC_IPC_SIDE_LOCAL,
    DWC_IPC_SIDE_REMOTE,
    DWC_IPC_SIDE_MAX
}                   DWC_side_t;
typedef enum {
    DWC_IPC_CMD_0 = 0,
    DWC_IPC_CMD_SETPORT,
    DWC_IPC_CMD_SETADDR,
    DWC_IPC_CMD_SETALL,
    DWC_IPC_CMD_RESOLVE,
    DWC_IPC_CMD_BIND,
    DWC_IPC_CMD_MAX
}                   DWC_cmd_t;
typedef int         DWC_error_code_t;
typedef size_t      DWC_length_t;
typedef int         DWC_timeout_t;
#define INFINITE_TIMEOUT        ((DWC_timeout_t)(0))
#define INVALID_TIMEOUT         ((DWC_timeout_t)(-1))
#define NOWAIT_TIMEOUT          ((DWC_timeout_t)(-2))
typedef char        DWC_char_t;
typedef void*       DWC_pointer_t;
typedef char*       DWC_string_t;
typedef unsigned int DWC_socklen_t; /* asv: the best way - use autoconf */
#if defined(__cplusplus)
typedef bool        DWC_bool_t;
#ifndef FALSE
#define FALSE       (0)
#endif
#ifndef TRUE
#define TRUE        (1)
#endif
#else /* ANSI C */
#ifndef FALSE
typedef enum {
    FALSE = 0,
    TRUE = !FALSE
}                   DWC_bool_t;
#else
typedef int         DWC_bool_t;
#endif /* __WIN32_DW */
#endif

typedef struct {
    DWC_length_t    max_len; /* IN: max length of log-buffer */
    DWC_length_t    cur_len; /* IN/OUT: current length of buffer for log-buffer */
    DWC_string_t    line;    /* IN: ptr to log-buffer */
} DWC_log_t;

#endif /* _DWC_TYPE_H */
