sub drweb {
  # Call DrWeb Daemon Perl-Wrapper Client
  &debug("drweb: starting scan of directory \"$scandir/$file_id\"...");
  local($drweb_verbose)="" if ($DEBUG);
  local($start_drweb_time)=[gettimeofday];
  &debug("drweb: run $drweb_binary $scandir/$file_id");
  $DD = `perl $drweb_binary $scandir/$file_id`;
  $drweb_status = ($? >> 8);
  &debug("drweb: wrapper return code($drweb_status) and string:\n$DD");
  if( $drweb_status eq 1 ) {
    @list = split(/\n/,$DD);
    $virus_description = '';    
    foreach( @list ) {        
        $virus_description .= "$_\n";
        $virus_found++;
    }
    &debug("drweb: Found a viruses:\n$virus_description");
    $description .= "\n--- drweb results ---\n$DD";
    $section=$apptype=$save_filename=$filename="";   
  } 
  elsif( $drweb_status eq 2 ) {
    $virus_description = "possible contain a mailbomb";    
    $virus_found=1;
    &debug("drweb: message possible contain a mailbomb");
    $description .= "\n--- drweb results ---\nmessage possible contain a mailbomb";
    $section=$apptype=$save_filename=$filename="";   
  }  
  elsif( $drweb_status eq 3 ) {
    $virus_description = "contain an unchecked objects";    
    $virus_found=1;
    &debug("drweb: message possible contain an unchecked objects");
    $description .= "\n--- drweb results ---\nmessage contain an unchecked objects";
    $section=$apptype=$save_filename=$filename="";   
  }  
  elsif( $drweb_status eq 10 ) {
    &debug("drweb: message has not been checked, but passed - $DD");
  }  
  elsif( $drweb_status > 0 ) {
    &tempfail("drweb: antivirus software failure");
  }  
  local($stop_drweb_time)=[gettimeofday];
  $drweb_time = tv_interval ($start_drweb_time, $stop_drweb_time);
  &debug("drweb: finished scan of dir \"$scandir/$file_id\" in $drweb_time secs");
}
