sub drweb {
  # Call DrWeb Daemon Perl-Wrapper Client
  &debug("drweb: starting scan of directory \"$scandir/$file_id\"...");
  my ($drweb_verbose)="" if ($DEBUG);
  my ($start_drweb_time)=[gettimeofday];
  my ($DD,$drweb_status,$stop_drweb_time,$drweb_time);
  &debug("drweb: run $drweb_binary $scandir/$file_id");
  $DD = `perl $drweb_binary $scandir/$file_id`;
  $drweb_status = ($? >> 8);
  &debug("drweb: wrapper return code($drweb_status) and string:\n$DD");
  if( $drweb_status eq 1 ) {
    my @list = split(/\n/,$DD);
    $quarantine_description = '';    
    foreach( @list ) {        
        $quarantine_description .= "$_\n";
        $quarantine_event++;
    }
    &debug("drweb: Found a viruses:\n$quarantine_description");
    $description .= "\n--- drweb results ---\n$DD";
  } 
  elsif( $drweb_status eq 2 ) {
    $quarantine_description = "possible contain a mailbomb";    
    $quarantine_event=1;
    &debug("drweb: message possible contain a mailbomb");
    $description .= "\n--- drweb results ---\nmessage possible contain a mailbomb";
  }  
  elsif( $drweb_status eq 3 ) {
    $quarantine_description = "contain an unchecked objects";    
    $quarantine_event=1;
    &debug("drweb: message possible contain an unchecked objects");
    $description .= "\n--- drweb results ---\nmessage contain an unchecked objects";
  }  
  elsif( $drweb_status eq 10 ) {
    &debug("drweb: message has not been checked, but passed - $DD");
  }  
  elsif( $drweb_status > 0 ) {
    &tempfail("drweb: antivirus software failure");
  }  
  my ($stop_drweb_time)=[gettimeofday];
  $drweb_time = tv_interval ($start_drweb_time, $stop_drweb_time);
  &debug("drweb: finished scan of dir \"$scandir/$file_id\" in $drweb_time secs");
}
